#!/usr/bin/perl
#process_cgi.pl. A Perl library for CGI processing.

sub form_method {
	$method=$ENV{'REQUEST_METHOD'};
}

sub path_info {
	$path=$ENV{'PATH_INFO'};
	$path=~ s/\///;
	$return=$path;
}

sub print_header {
	if (!defined(@_)) {
		print "Content-type: text/html\n\n";
	}
	else {
		print "Location: @_\n\n";
	}
}

sub parse_input {
	if (defined(@_)) {
		local(*input)=@_;
	}
	else {
		local(*input)="*cgiinput";
	}
	local ($temp,@pairs);
	if (&form_method eq 'POST') {
		read(STDIN,$temp,$ENV{'CONTENT_LENGTH'});
	}
	else {
		$temp=$ENV{'QUERY_STRING'};
	}
	if ($temp ne '') {
		@pairs=split(/&/,$temp);
		foreach $item(@pairs) {
			($key,$content)=split (/=/,$item,2);
			$content=~tr/+/ /;
			$content=~ s/%(..)/pack("c",hex($1))/ge;
			if (!defined($input{$key})) {
				$input{$key}=$content;
			}
			else {
				$input{$key} .= "\0$content";
			}
		}
		return 1;
	}
	else {
		return 0;
	}
}
return 1;

